﻿//*********************************************************
//
// Copyright(C) Seiko Epson Corporation 2021. All rights reserved.
//
//*********************************************************

using System;
using System.Collections.Generic;

namespace SampleDisplayControl.Watchers
{
    internal class MoverioInfo : IEquatable<MoverioInfo>
    {
        public readonly MoverioType type;
        public readonly string id;

        public MoverioInfo(MoverioType type, string id)
        {
            this.type = type;
            this.id = id;
        }

        public override bool Equals(object obj)
        {
            return Equals(obj as MoverioInfo);
        }

        public bool Equals(MoverioInfo other)
        {
            return other != null &&
                   id == other.id &&
                   EqualityComparer<MoverioType>.Default.Equals(type, other.type);
        }

        public override int GetHashCode()
        {
            var hashCode = -1056084179;
            hashCode = (hashCode * -1521134295) + EqualityComparer<string>.Default.GetHashCode(id);
            hashCode = (hashCode * -1521134295) + EqualityComparer<MoverioType>.Default.GetHashCode(type);
            return hashCode;
        }

        public static bool operator ==(MoverioInfo left, MoverioInfo right)
        {
            return EqualityComparer<MoverioInfo>.Default.Equals(left, right);
        }

        public static bool operator !=(MoverioInfo left, MoverioInfo right)
        {
            return !(left == right);
        }
    }
}
