﻿//*********************************************************
//
// Copyright(C) Seiko Epson Corporation 2019. All rights reserved.
//
//*********************************************************

using Microsoft.Toolkit.Uwp.UI.Controls;
using SampleSensorDataChart.Sensors;
using Windows.ApplicationModel;
using Windows.Foundation;
using Windows.UI.ViewManagement;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Navigation;

namespace SampleSensorDataChart
{
    public sealed partial class MainPage : Page
    {
        private ISensor currentSensor;

        public MainPage()
        {
            InitializeComponent();
            ApplicationView.GetForCurrentView().SetPreferredMinSize(new Size(800, 600));
            ApplicationView.PreferredLaunchViewSize = new Size(800, 600);
            ApplicationView.PreferredLaunchWindowingMode = ApplicationViewWindowingMode.PreferredLaunchViewSize;
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            Application.Current.Resuming += Current_Resuming;
            Application.Current.Suspending += Current_Suspending;
        }

        protected override void OnNavigatingFrom(NavigatingCancelEventArgs e)
        {
            Application.Current.Resuming -= Current_Resuming;
            Application.Current.Suspending -= Current_Suspending;
        }

        private void Current_Resuming(object sender, object e)
        {
            currentSensor?.Active();
        }

        private void Current_Suspending(object sender, SuspendingEventArgs e)
        {
            currentSensor?.Inactive();
        }

        private void SensorsTab_SelectionChanged(object sender, SelectionChangedEventArgs _)
        {
            SensorChanges();
        }

        private void SensorChanges()
        {
            var tabItem = sensorsTab.SelectedItem as TabViewItem;
            if (!(tabItem.Content is ISensor sensor))
            {
                return;
            }

            currentSensor?.Inactive();
            sensor.Active();

            currentSensor = sensor;
        }
    }
}
